var JIM = new JMessage();
var main_langue = {
	zh_CN: {
		sell: '出售',
		seller: '卖家',
		buy: '购买',
		buyer: '买家',
		obligation: '待付款',
		paid: '已付款',
		waitBuyerPay: '等待买家付款',
		buyerPaid: '买家已付款',
		finish: '已完成',
		cancel: '已取消',
		appeal: '申诉中',
		weixin: '微信',
		zhifubao: '支付宝',
		bank: '银行卡',
		turnover: '订单金额',
		price: '单价',
		amount: '数量',
		orderNumber: '流水号',
		createTime: '创建时间',
		appealContent: '申诉结果',
		appealContentNull: '无',
		adRemark: '广告备注',
		adRemarkNull: '无',
		payBtn: '去支付',
		appealBtn: '申诉',
		receiptBtn: '确认收款',
		receiptContent1: '请确认已收到买家付款',
		receiptContent2: '点击“确认收款”放币给买家',
		pass: '密码',
		passPlaceholder: '请输入密码',
		affirm: '确认',
		cancelBtn: '取消订单',
		cancelContent: '如您已向卖家付款，取消订单您将会损失付款资金！',
		cancelTitie: '取消',
		affirmCancel: '确认取消',
		close: '关闭',
		totalMoney: '交易总额',
		note1: '请输入您的信息',
		send: '发送',
		passOverTime: '密码存储时间已过期,请重新输入',
		inportPass: '请输入密码！',
		logInElse: '您的账号在别处登录！',
		waiting: '等待中...',
		handleSuccess: '操作成功！',
		netError: '网络异常，请刷新重试！',
		note1: '发送的消息不能为空',
		note2: '请输入消息',
        note3:'图片内部格式错误',
        note4:'图片大小不能超过8M',
        note5:'发送图片失败',
        mustLogin:'请先登录!',
	},
	zh_HK: {
		sell: '出售',
		seller: '賣家',
		buy: '購買',
		buyer: '買家',
		obligation: '待付款',
		paid: '已付款',
		waitBuyerPay: '等待買家付款',
		buyerPaid: '買家已付款',
		finish: '已完成',
		cancel: '已取消',
		appeal: '申訴中',
		weixin: '微信',
		zhifubao: '支付寶',
		bank: '銀行卡',
		turnover: '訂單金額',
		price: '單價',
		amount: '數量',
		orderNumber: '流水號',
		createTime: '創建時間',
		appealContent: '申訴結果',
		appealContentNull: '無',
		adRemark: '廣告備註',
		adRemarkNull: '無',
		payBtn: '去支付',
		appealBtn: '申訴',
		receiptBtn: '確認收款',
		receiptContent1: '請確認已收到買家付款',
		receiptContent2: '點擊“確認收款”放幣給買家',
		pass: '密碼',
		passPlaceholder: '請輸入密碼',
		affirm: '確認',
		cancelBtn: '取消訂單',
		cancelContent: '如您已向賣家付款，取消訂單您將會損失付款資金！',
		cancelTitie: '取消',
		affirmCancel: '確認取消',
		close: '關閉',
		totalMoney: '交易總額',
		note1: '請輸入您的資訊',
		send: '發送',
		passOverTime: '密碼存儲時間已過期,請重新輸入',
		inportPass: '請輸入密碼！',
		logInElse: '您的帳號在別處登錄！',
		waiting: '等待中...',
		handleSuccess: '操作成功！',
		netError: '網路異常，請刷新重試！',
		note1: '發送的消息不能爲空',
		note2: '請輸入消息',
		note3:'圖片内部格式錯誤',
        note4:'圖片大小不能超過8M',
        note5:'發送圖片失敗',
        mustLogin:'請先登陸!',
	},
	en_US: {
		sell: 'Sell ',
		seller: 'Seller',
		buy: 'Buy ',
		buyer: 'Buyer',
		obligation: 'Pending payment',
		paid: 'Paid',
		waitBuyerPay: 'Waiting for buyers payment',
		buyerPaid: 'The buyer has paid',
		finish: 'completed',
		cancel: 'Cancelled',
		appeal: 'Appeal',
		weixin: 'WeChat',
		zhifubao: 'Alipay',
		bank: 'Bank card',
		turnover: 'turnover',
		price: 'price',
		amount: 'amount',
		orderNumber: 'number',
		createTime: 'Create time',
		appealContent: 'Appeal results',
		appealContentNull: 'no',
		adRemark: 'Advertising notes',
		adRemarkNull: 'no',
		payBtn: 'Go to pay',
		appealBtn: 'appeal',
		receiptBtn: 'confirm',
		receiptContent1: 'Please confirm that you have received payment from the buyer',
		receiptContent2: 'Click Confirm receipts to release coins to buyers',
		pass: 'password',
		passPlaceholder: 'Please enter your password',
		affirm: 'confirm',
		cancelBtn: 'cancel order',
		cancelContent: 'If you have already paid the seller, you will lose your payment if you cancel the order!',
		cancelTitie: 'cancel',
		affirmCancel: 'confirm cancel',
		close: 'shut down',
		totalMoney: 'Total amount',
		note1: 'Please enter your information',
		send: 'send',
		passOverTime: 'The password storage time has expired, please re-enter',
		inportPass: 'Please enter your password!',
		logInElse: 'Your account is logged in elsewhere!',
		waiting: 'Waiting...',
		handleSuccess: 'Successful operation!',
		netError: 'Network exception, please refresh and try again!',
		note1: 'The message sent cannot be empty',
		note2: 'Please enter a message',
		note3:'Image internal format error',
        note4:'Image size cannot exceed 8M',
        note5:'Sending a picture failed',
        mustLogin:'Must login',
	}
};
//2、页面上所有需要国际化的文字，包括提示，都通过Vue去引用，例子：
var langueKey = app.getLanguageLocalStorage(); //获取国际化语种

var langues = main_langue[langueKey]; // 获取国际化语种数据
//3、每个页面都需要加上以下的方法：

window.addEventListener('switchLangueData', function(e) {
	//dataInfo为Vue对象的名称
	main.langues = main_langue[e.detail];
});
var main = new Vue({
	el: "#main",
	data: {
		langues: langues,
		records: [],
		inputMsg: '',
		//发送消息的input值
		msgBody: {
			msgType: '',
			text: '',
			mediaId: ''
		},
		initImgUrl: [],
		chatImgUrl: '',
		// 聊天窗口的图片
		nick_name: '',
		//这个昵称只有在发送消息后，自己这边显示有用
		target_user_nickname: '',
		//机关消息接收方的昵称
		target_username: '',
		//机关消息接收方的用户名
		t_userId: '',
		//当前消息接收方用户ID
		f_userId: '',
		//当前消息发送方Id
		base_file_url: app.walletFileUrl,
		//基础路
		popover_Status: false //聊天框顯示狀態

	},
	mounted: function mounted() {
		var that = this;
	},
	computed: {
		contHeight: function contHeight() {
			return '70%';
		},
		orderCancel: function orderCancel() {
			return dataInfo.orderCancel;
		},
		orderFinish: function orderFinish() {
			return dataInfo.orderFinish;
		},
		orderAppeal: function orderAppeal() {
			return dataInfo.orderAppeal;
		},
		orderNew: function orderNew() {
			return dataInfo.orderNew;
		},
		roleBuy: function roleBuy() {
			return dataInfo.roleBuy;
		},
		roleSell: function roleSell() {
			return dataInfo.roleSell;
		},
		orderUnderway: function orderUnderway() {
			return dataInfo.orderUnderway;
		},
		order: function order() {
			return dataInfo.order;
		},
		count_down: function count_down() {
			return dataInfo.count_down;
		},
		//聊天框买卖家的顶部头像信息
		img_choice: function img_choice() {
			if(dataInfo.order.role == 'BUY') {
				if(!dataInfo.order.sellAvatar) {
					return '../../../mine/img/touxiang_mr.png';
				} else {
					return this.base_file_url + dataInfo.order.sellAvatar;
				}
			} else {
				if(!dataInfo.order.buyAvatar) {
					return '../../../mine/img/touxiang_mr.png';
				} else {
					return this.base_file_url + dataInfo.order.buyAvatar;
				}
			}
		},
		//聊天框买卖家的顶部昵称信息
		nickname_choice: function nickname_choice() {
			if(dataInfo.order.role == 'BUY') {
				return dataInfo.order.sellNickName;
			} else {
				return dataInfo.order.buyNickName;
			}
		}
	},
	methods: {
		//聊天框买卖家的头像信息
		img_buysell: function img_buysell(avatar) {
			if(!avatar) {
				return '../../../mine/img/touxiang_mr.png';
			} else {
				return this.base_file_url + avatar;
			}
		},
		// 关闭聊天窗口
		cancelChat: function cancelChat() {
			this.popover_Status = false;
			dataInfo.bgStatus = false;
		},
		//滚动到底
		scrollToBottom: function scrollToBottom() {
			var _this = this;
			setTimeout(function() {
				//滚动条长度
				var currentDistance = _this.$refs.xwBody.scrollHeight - _this.$refs.xwBody.clientHeight;
				//当前滚动条距离顶部的距离
				var currentScroll_y = _this.$refs.xwBody.scrollTop;
				if(currentDistance > 0 && currentDistance > currentScroll_y) {
					currentScroll_y = Math.ceil((currentDistance - currentScroll_y) / 10) + currentScroll_y;
					currentScroll_y = currentScroll_y > currentDistance ? currentDistance : currentScroll_y;
					//微信和qq浏览器不支持 scrollTo？
					//this.$refs.xwBody.scrollTo(0,currentScroll_y);
					_this.$refs.xwBody.scrollTop = currentScroll_y;

					_this.scrollToBottom();
				}
			}, 13);
		},
		// 聚焦输入框
		onFocusText: function onFocusText() {
			this.scrollToBottom();
		},
		//发送消息
		sendMsg: function sendMsg() {
			var that = this;
			// 输入框的内容
			var message = this.inputMsg.trim();
			if(message != '') {
				var msgBody = getMsgBody("text", message, "");
				that.pushMsg("text", msgBody);
				console.log("消息" + JSON.stringify(msgBody)); // 调用JMsend的发送消息

				sendSingleMsg(that.target_username, message, function(data) {
					that.msgBody.msgType = 'text';
					that.msgBody.text = message; //保存用户的消息记录

					saveMessageLog(dataInfo.order.id, that.t_userId, that.f_userId, 'text', 0, JSON.stringify(that.msgBody));
				});
				this.scrollToBottom();
				this.inputMsg = '';
			} else {
				mui.toast(main.langues.note1);
			}
		},
		// 把消息push到records这个对象
		pushMsg: function pushMsg(msgType, msgBody) {
			var oneMsg = getMsg(msgType, msgBody, this.t_userId, this.f_userId, this.target_user_nickname);
			oneMsg.fromUser.avatar = app.getUserLocalStorage().avatar;
			console.log("hello" + JSON.stringify(oneMsg));
			this.records.push(oneMsg);
		},
		// 发送聊天图片
		sendChatPic: function sendChatPic(e) {
			var that = this;
			var e = window.event || event; 
			// 获取当前选中的文件
			var oFile = e.target.files[0];
			console.log(JSON.stringify(oFile));
			var fd = new FormData();
			fd.append('file', oFile);
			console.log(JSON.stringify(fd));
			sendSinglePic(that.target_username, fd, function(data, res) {
				var msgBody = getMsgBody("image", "", res.content.msg_body.media_id);
				getResource(res.content.msg_body.media_id, function(url) {
					var oneMsg = getMsg("image", msgBody, that.t_userId, that.f_userId, that.target_user_nickname);
					oneMsg.fromUser.avatar = app.getUserLocalStorage().avatar;
					oneMsg.imgUtl = url; 
					main.records.push(oneMsg);
					that.scrollToBottom();
				}); 
				// 保存消息的参数
				that.msgBody.msgType = 'image';
				that.msgBody.mediaId = res.content.msg_body.media_id;
				//保存用户的消息记录
				saveMessageLog(dataInfo.order.id, that.t_userId, that.f_userId, 'image', 0, JSON.stringify(that.msgBody));
			});
		}
	}
}); // 获取用户的用户名，密码

function getBuySellInfo(userId, fun) {
	ajaxJm('jgim/getJGAccount', {
		userId: userId
	}, 'get', function(res) {
		fun(res);
		console.log("获取用户的用户名，密码" + JSON.stringify(res));
	});
} // 实时监听聊天信息

JIM.onMsgReceive(function(data) {
	console.log("2222" + data.messages[0].content.msg_type);

	if(data.messages[0].content.msg_type == "text") {
		var msgBody = getMsgBody("text", data.messages[0].content.msg_body.text, null); //接受消息时,nickName应该是对面的

		var onwMsg = getMsg("text", msgBody, main.f_userId, main.t_userId, main.target_user_nickname);
		console.log("订单消息"+ JSON.stringify(onwMsg));
		if(data.messages[0].content.from_name == "nodeCue") {
			onwMsg.nodeCue = 1;
		}

		if(main.f_userId != data.messages[0].content.from_id) {
			if(dataInfo.order.role == 'BUY') {
				onwMsg.fromUser.avatar = dataInfo.order.sellAvatar;
			} else {
				onwMsg.fromUser.avatar = dataInfo.order.buyAvatar;
			}

			main.records.push(onwMsg);
			
		}

		main.scrollToBottom();
	} else {
		var msgBody = getMsgBody("image", "", data.messages[0].content.msg_body.media_id);
		var onwMsg = getMsg("image", msgBody, main.f_userId, main.t_userId, main.target_user_nickname);
		getResource(data.messages[0].content.msg_body.media_id, function(url) {
			console.log("00000" + url);
			onwMsg.imgUtl = url;

			if(dataInfo.order.role == 'BUY') {
				onwMsg.fromUser.avatar = dataInfo.order.sellAvatar;
			} else {
				onwMsg.fromUser.avatar = dataInfo.order.buyAvatar;
			}

			main.records.push(onwMsg);
		});
	}
});