// 极光初始化
function init(appkey, random_str, signature, timestamp, fun) {
	//极光初始化
	JIM.init({
		"appkey": appkey,
		"random_str": random_str,
		"signature": signature,
		"timestamp": timestamp,
		"flag": 0
	}).onSuccess(function(data) {
		console.log("极光初始化成功>>>" + JSON.stringify(data))
		fun()
	}).onFail(function(data) {
		// console.log("极光初始化失败>>>", data)
	})
}

//极光登录
function signIn(username, password) {
	JIM.login({
		'username': username,
		'password': password
	}).onSuccess(function(data) {
		console.log("极光登录成功>>>" + JSON.stringify(data));
		// 获取买家的消息记录
		ajaxJm('jgim/getUserMessages', {
			dataId: dataInfo.order.id,
			userId: main.f_userId,
			order: '',
			page: '',
			size: ''
		}, 'get', function(res) {
			console.log("獲取>>>" + JSON.stringify(res));
			main.records = [];
			for(var i = 0; i < res.length; i++) {
				var obj = res[i];
				obj.imgUrl = '';
				main.records[i] = obj;
				(function(obj, index) {
					if(obj.msgType === 'image') {
						getResource(obj.messageDTO.mediaId, function(imgUrl) {
							obj.imgUtl = imgUrl;
							main.records[index] = JSON.parse(JSON.stringify(obj));
							main.$forceUpdate();
						})
					}
				})(obj, i)
			}
			mui.previewImage();
			main.scrollToBottom();
		})

	}).onFail(function(data) {
		console.log("极光登录失败>>>"+JSON.stringify(data))
	})
}

// 极光发送文本消息
function sendSingleMsg(target_username, message, fun) {
	JIM.sendSingleMsg({
		'target_username': target_username,
		'content': message
	}).onSuccess(function(data) {
		fun(data);
	}).onFail(function(data) {
		console.log("发送消息失败：", data)
	})

}

// 极光发送图片
function sendSinglePic(target_username, image, fun) {
    plus.nativeUI.showWaiting(main.langues.waiting);
	JIM.sendSinglePic({
		'target_username': target_username,
		'image': image
	}).onSuccess(function(data, res) {
		plus.nativeUI.closeWaiting();
		fun(data, res)
	}).onFail(function(data) {
		plus.nativeUI.closeWaiting();
		if(data.error.code === 898000){
		   mui.toast(main.langues.note3);
		}else if(data.error.code === 880210){
		   mui.toast(main.langues.note4);
		}else{
			 console.log("极光发送图片失败："+ JSON.stringify(data))
		     mui.toast(main.langues.note5);
		}
	})
}

//保存用户的消息记录
function saveMessageLog(dataId, targetUserId, fromUserId, msgType, nodeCue, msgBody) {
	console.log("111111111111111")
	ajaxJm('jgim/saveMessageLog', {
		dataId: dataId,
		targetUserId: targetUserId,
		fromUserId: fromUserId,
		msgType: msgType,
		nodeCue: nodeCue,
		msgBody: msgBody
	}, 'post', function(res) {
		console.log("保存用户信息成功：" + JSON.stringify(res));
	})
}

//获取极光资源路径
function getResource(mediaId, fun) {
	ajaxJm('jgim/getResource', {
		mediaId: mediaId
	}, "get", function(res) {
		console.log("返回图片路径成功：" + res.url);
		fun(res.url)
	})
}

// 本地的messageDTO
function getMsgBody(msg_type, text, mediaId) {
	return {
		"duration": 0,
		"extras": "string",
		"fname": "string",
		"format": "string",
		"fsize": 0,
		"height": 0,
		"id": 0,
		"mediaCrc32": "string",
		"mediaId": mediaId,
		"msgType": msg_type,
		"text": text,
		"width": 0
	}
}

// 消息主体
function getMsg(msg_type, msgBody, tid, fid, nickName) {
	return {
		"dataId": dataInfo.order.id,
		"fromId": fid,
		"fromUser": {
			"avatar": "",
			"id": "string",
			"mobilePhone": "string",
			"nickName": nickName,
		},
		"gmtCreate": new Date().toLocaleTimeString(),
		"gmtModified": "string",
		"id": 0,
		"messageDTO": msgBody,
		"msgId": 0,
		"msgType": msg_type,
		"nodeCue": 0,
		"ptype": "string",
		"status": "string",
		"targetId": tid
	}
}