/*********************************\
 * $BASE-CONFIG
\*********************************/

/**
 * $YH　2018-12-16 15:04:28
 * require 配置文件
 * 描述：主要用于配置js包路径，及其调用Key值
 */
var libUrl = "../../../lib/js";
require.config({
	paths: {
		mui: libUrl + "/mui.min", // mui基本库
		muiPullToRefresh: libUrl + "/mui.pullToRefresh", // 上拉加载下拉刷新的插件库——mui插件库
		muiPullToRefreshMaterial: libUrl + "/mui.pullToRefresh.material", // 上拉加载下拉刷新的插件库——mui插件库
		Vue: libUrl + "/vue.min", // vue基本库
		app: libUrl + "/app", //app 通用方法
		ajaxUtil: libUrl + "/app.ajax", // app 请求通用方法
		alertUtil: libUrl + "/app.alert", // app 弹窗工具方法
		walletApi: "../js/wallet.api", // 钱包接口js
		jsencrypt: libUrl + "/jsencrypt.min", // 非对称加密方法
		baseUtil: "../js/base.util", // 非对称加密方法
		baseHandle: "../js/base.handle",// 数据处理
		Swiper: libUrl + "/swiper.min" 
	},
	shim: {
		Vue: {
			exports: "Vue"
		},
		mui: {
			exports: "mui"
		},
		Swiper: {
			exports: "Swiper"
		},
		jsencrypt: {
			exports: "jsencrypt"
		},
		alertUtil: {
			exports: "alertUtil",
			deps: ['mui', 'app'],
			init: function() {
				var data = {}
				data.getAlertFactory = this.getAlertFactory;
				return data;
			}
		},
		muiPullToRefresh: {
			deps: ['mui'],
			exports: 'muiPullToRefresh'
		},
		muiPullToRefreshMaterial: {
			deps: ['mui', 'muiPullToRefresh'],
			exports: 'muiPullToRefreshMaterial'
		},
		app: {
			exports: "app"
		}
	}
})